/* Base document:
****[ ITRON4.0͸ ǥå       ]
****[ ITRON4.0 C++ API Ͱ                       ]
****[ :  ϡ δԡ˭Ѳʳء]
****[ ǽ: 2000ǯ425                         ]
** Implementer:
**   Masaki Muranaka (Monami software & Limited Partners)
*/

#include <kernel.h>

// ͥ륢å饹 [S]
// оݥ֥ȤΤʤӥ
// () Сϥɥ
// ߥϥɥ
// ӥ
// CPU㳰ϥɥ
// Ϥ٤줾εưϤϡ
// ХʴؿؤΥݥ󥿤Ǥ뤳ȡ
class Kernel
{
    public:
	// ƥ
	static ER	getTime(SYSTIM *p_systim);		// get_tim [S]
	static ER	setTime(SYSTIM *p_systim);		// set_tim [S]
	static ER	iSignalTime();				// isig_tim [S]

	// Сϥɥ鵡ǽ
	//static ER	defineOverrunHandler(T_DOVR pk_dovr);	// def_ovr

	// ƥִǽ
	static ER	rotateReadyQueue(PRI tskpri);		// rot_rdq [S]
	static ER	iRotateReadyQueue(PRI tskpri);		// rot_rdq [S]
	static ER	getRunningTaskID(ID *p_tskid);		// get_tid [S]
	static ER	iGetRunningTaskID(ID *p_tskid);		// iget_tid [S]
	static ER	lockCPU();				// loc_cpu [S]
	static ER	iLockCPU();				// iloc_cpu [S]
	static ER	unlockCPU();				// unl_cpu [S]
	static ER	iUnlockCPU();				// iunl_cpu [S]
	static ER	disableDispatch();			// dis_dsp [S]
	static ER	enableDispatch();			// ena_dsp [S]
	static BOOL	senseContext();				// sns_ctx [S]
	static BOOL	senseLock();				// sns_loc [S]
	static BOOL	senseDispatch();			// sns_dsp [S]
	static BOOL	senseDispatchPending();			// sns_dpn [S]
	//static ER	referSystem(T_RSYS *pk_rsys);		// ref_sys

#if 0
	// ߴǽ
	static ER	defineInterruptHandler(INHNO inhno, T_DINH *pk_dinh);
								// def_inh
	static ER	disableInterrupt(INTNO intno);		// dis_int
	static ER	enableInterrupt(INTNO intno);		// ena_int
	static ER	changeInterruptXxxxx(IXXXX ixxxx);	// chg_ixx
	static ER	getInterruptXxxxx(IXXXX *p_ixxxx);	// ref_ixx

	// ӥǽ
	static ER	defineServiceCall(FN fncd, T_DSVC *pk_dsvc);
								// def_svc
	static ER_UINT	callServiceCall(FN fncd, VP_INT par1, ...);
								// cal_svc

	// ƥ๽ǽ
	static ER	defineCPUExceptionHandler(EXCNO excno,T_DEXC *pk_dexc);
								// def_exc
	static ER	referConfiguration(T_RCFG *pk_rcfg);	// ref_cfg
	static ER	referVersion(T_RVER *pk_rver);		// ref_ver
#endif
};


// å饹 [S]
// () Ϥ٤εưϤϡ
// ХʴؿؤΥݥ󥿤Ǥ뤳ȡ
// ޤ㳰ϥɥϤ٤㳰ϥɥ
// ưϤ⡤ХʴؿؤΥݥ󥿤Ǥ뤳ȡ
class Task
{
    public:
	// 󥹥ȥ饯
	Task(ID tskid);				// IDֹΥå [S]
#if 0
	Task(ID tskid, T_CTSK *pk_ctsk);	// cre_tsk
	Task(T_CTSK *pk_ctsk);			// acre_tsk
#endif

	// IDֹμ
	ID	getId();			// IDֹμ [S]

	// ǽ
	//ER	create(T_CTSK *pk_ctsk);	// cre_tsk
	//ER 	delete();			// del_tsk
	ER 	activate();			// act_tsk [S]
	ER 	iActivate();			// iact_tsk [S]
	ER 	cancelActivate();		// can_act [S]
	ER 	start(VP_INT stacd);		// sta_tsk
	ER 	terminate();			// ter_tsk [S]
	ER 	changePriority(PRI tskpri);	// chg_pri [S]
	ER 	getPriority(PRI *p_tskpri);	// get_pri [S]
	//ER	refer(T_RTSK *pk_rtsk);		// ref_tsk
	//ER	refer(T_RTST *pk_rtst);		// ref_tst

	// °Ʊǽ
	ER	wakeup();			// wup_tsk [S]
	ER	iWakeup();			// iwup_tsk [S]
	ER_UINT	cancelWakeup();			// can_wup [S]
	ER	releaseWait();			// rel_wai [S]
	ER	iReleaseWait();			// irel_wai [S]
	ER	suspend();			// sus_tsk [S]
	ER	resume();			// rsm_tsk [S]
	ER	forceResume();			// frsm_tsk [S]

	// 㳰ǽ
	//ER	defineTaskException(T_DTEX *pk_dtex);	// def_tex
	ER	raiseTaskException(TEXPTN rasptn);	// ras_tex [S]
	ER	iRaiseTaskException(TEXPTN rasptn);	// iras_tex [S]
	//ER	referTaskException(T_RTEX *pk_rtex);	// ref_tex

	// Сϥɥ鵡ǽ
	//ER	startOverrunHandler(OVRTIM ovrtim);	// sta_ovr
	ER	stopOverrunHandler();			// stp_ovr
	//ER	referOverrunHandler(T_ROVR *pk_rovr);	// sta_ovr

	// ʲϼоݤȤ륵ӥʥ饹᥽åɡ

	// ǽ
	static void 	exit();				// ext_tsk [S]
	static void 	exitDelete();			// exd_tsk

	// °Ʊǽ
	static ER	sleep();			// slp_tsk [S]
	static ER	sleep(TMO tmo);			// tslp_tsk [S]
	static ER	delay(RELTIM dlytim);		// dly_tsk [S]

	// 㳰ǽ
	static ER	disableTaskException();		// dis_tex [S]
	static ER	enableTaskException();		// ena_tex [S]
	static BOOL	senseTaskException();		// sns_tex [S]
    private:
	ID tskid;
};


//ޥեå饹 [S]
class Semaphore
{
    public:
	// 󥹥ȥ饯
	Semaphore(ID semid);				// IDֹΥå [S]
#if 0
	Semaphore(ID semid, T_CSEM *pk_csem);		// cre_sem
	Semaphore(T_CSEM *pk_csem);			// acre_sem
#endif

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// ޥեǽ
	//ER	create(T_CSEM *pk_csem);		// cre_sem
	//ER	delete();				// del_sem
	ER	signal();				// sig_sem [S]
	ER	iSignal();				// isig_sem [S]
	ER	wait();					// wai_sem [S]
	ER	wait(TMO tmout);			// twai_sem [S]
	ER	poll();					// pol_sem [S]
	//ER	refer(T_RSEM *pk_rsem);			// ref_sem
    private:
	ID semid;
};


//٥ȥե饰å饹 [S]
class EventFlag
{
    public:
	// 󥹥ȥ饯
	EventFlag(ID flgid);				// IDֹΥå [S]
#if 0
	EventFlag(ID flgid, T_CFLG *pk_cflg);		// cre_flg
	EventFlag(T_CFLG *pk_cflg);			// acre_flg
#endif

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// ޥեǽ
	//ER	create(T_CFLG *pk_cflg);		// cre_flg
	//ER	delete();				// del_flg
	ER	set(FLGPTN senptn);			// set_flg [S]
	ER	iSet(FLGPTN senptn);			// iset_flg [S]
	ER	clear(FLGPTN clrptn);			// clr_flg [S]
	ER	wait(FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn);
							// wai_flg [S]
	ER	wait(FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn, TMO tmout);
							// twai_flg [S]
	ER	poll(FLGPTN waiptn, MODE wfmode, FLGPTN *p_flgptn);
							// pol_flg [S]
	//ER	refer(T_RFLG *pk_rflg);			// ref_flg
    private:
	ID flgid;
};


//ǡ塼å饹 [S]
class DataQueue
{
    public:
	// 󥹥ȥ饯
	DataQueue(ID dtqid);				// IDֹΥå [S]
#if 0
	DataQueue(ID dtqid, T_CDTQ *pk_cdtq);		// cre_dtq
	DataQueue(T_CDTQ *pk_cdtq);			// acre_dtq
#endif

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// ޥեǽ
	//ER	create(T_CDTQ *pk_cdtq);		// cre_dtq
	//ER	delete();				// del_dtq
	ER	send(VP_INT data);			// snd_dtq [S]
	ER	send(VP_INT data, TMO tmout);		// tsnd_dtq [S]
	ER	pollSend(VP_INT data);			// psnd_dtq [S]
	ER	iPollSend(VP_INT data);			// ipsnd_dtq [S]
	ER	forceSend(VP_INT data);			// fsnd_dtq [S]
	ER	iForceSend(VP_INT data);		// ifsnd_dtq [S]
	ER	receive(VP_INT *p_data);		// rcv_dtq [S]
	ER	receive(VP_INT *p_data, TMO tmout);	// trcv_dtq [S]
	ER	pollReceive(VP_INT *p_data);		// prcv_dtq [S]
	//ER	refer(T_RDTQ *pk_rdtq);			// ref_dtq
    private:
	ID dtqid;
};


//᡼ܥåå饹 [S]
class MailBox
{
    public:
	// 󥹥ȥ饯
	MailBox(ID mbxid);				// IDֹΥå [S]
#if 0
	MailBox(ID mbxid, T_CMBX *pk_cmbx);		// cre_mbx
	MailBox(T_CMBX *pk_cmbx);			// acre_mbx
#endif

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// ޥեǽ
	//ER	create(T_CMBX *pk_cmbx);		// cre_mbx
	//ER	delete();				// del_mbx
	ER	send(T_MSG *pk_msg);			// snd_mbx [S]
	ER	receive(T_MSG **ppk_msg);		// rcv_mbx [S]
	ER	receive(T_MSG **ppk_msg, TMO tmout);	// trcv_mbx [S]
	ER	pollReceive(T_MSG **ppk_msg);		// prcv_mbx [S]
	//ER	refer(T_RMBX *pk_rmbx);			// ref_mbx
    private:
	ID mbxid;
};


#if 0
//ߥ塼ƥåå饹
class Mutex
{
    public:
	// 󥹥ȥ饯
	Mutex(ID mtxid);				// IDֹΥå
	Mutex(ID mtxid, T_CMTX *pk_cmtx);		// cre_mtx
	Mutex(T_CMTX *pk_cmtx);				// acre_mtx

	// IDֹμ
	ID	getId();				// IDֹμ

	// ߥ塼ƥåǽ
	ER	create(T_CMTX *pk_cmtx);		// cre_mtx
	//ER	delete();				// del_mtx
	ER	lock();					// loc_mtx
	ER	lock(TMO tmout);			// tloc_mtx
	ER	pollLock();				// ploc_mtx
	ER	unlock();				// unk_mtx
	ER	refer(T_RMTX *pk_rmtx);			// ref_mtx
};
#endif


#if 0
//åХåեå饹
class MessageBuffer
{
    public:
	// 󥹥ȥ饯
	MessageBuffer(ID mbfid);			// IDֹΥå
	MessageBuffer(ID mbfid, T_CMBF *pk_cmbf);	// cre_mbf
	MessageBuffer(T_CMBF *pk_cmbf);			// acre_mbf

	// IDֹμ
	ID	getId();				// IDֹμ

	// åХåեǽ
	ER	create(T_CMBF *pk_cmbf);		// cre_mbf
	//ER	delete();				// del_mbf
	ER	send(VP msg, UINT msgsz);		// snd_mbf
	ER	send(VP msg, UINT msgsz, TMO tmout);	// tsnd_mbf
	ER	pollSend(VP msg, UINT msgsz);		// psnd_mbf
	ER_UINT	receive(VP msg);			// rcv_mbf
	ER_UINT	receive(VP msg, TMO tmout);		// trcv_mbf
	ER_UINT	pollReceive(VP msg);			// prcv_mbf
	ER	refer(T_RMBF *pk_rmbf);			// ref_mbf
};
#endif


#if 0
//ǥ֥ݡȥå饹
//() JTRONͤǤϡݡȥå饹ʥ饹̾: PortˤȤƤ롥
//() JTRONͤǤϡaccept  pollAccept ϥǥ֥å饹
//ʥ饹̾: RedezvousˤΥ󥹥󥹤֤
// C++ API ǤϡưŪɬ򤱤뤿ˡ
// ǥֹ֤ȤȤ
class RendezvousPort
{
    public:
	// 󥹥ȥ饯
	RendezvousPort(ID porid);			// IDֹΥå
	RendezvousPort(ID porid, T_CPOR *pk_cpor);	// cre_por
	RendezvousPort(T_CPOR *pk_cpor);		// acre_por

	// IDֹμ
	ID	getId();				// IDֹμ

	// ǥֵǽ
	ER	create(T_CPOR *pk_cpor);		// cre_por
	//ER	delete();				// del_por
	ER_UINT	call(RDVPTN calptn, VP msg, UINT cmsgsz);
							// cal_por
	ER_UINT	call(RDVPTN calptn, VP msg, UINT cmsgsz, TMO tmout);
							// tcal_por
	ER_UINT	accept(RDVPTN acpptn, RDVNO *p_rdvno, VP msg);
							// acp_por
	ER_UINT	accept(RDVPTN acpptn, RDVNO *p_rdvno, VP msg, TMO tmout);
							// tacp_por
	ER_UINT	pollAccept(RDVPTN acpptn, RDVNO *p_rdvno, VP msg);
							// pacp_por
	ER	forward(RDVPTN calptn, RDVNO rdvno, VP msg, UINT cmsgsz);
							// fwd_por
	ER	refer(T_RPOR *pk_rpor);			// ref_por
};
#endif

#if 0
//ǥ֥å饹
class Rendezvous
{
    public:
	// 󥹥ȥ饯
	Rendezvous(RDVNO rdvno);		// ǥֹΥå

	// ǥֹμ
	RDVNO	getNo();			// ǥֹμ

	// ǥֵǽ
	ER	reply(VP msg, UINT rmsgsz);	// rpl_rdv
	ER	refer(T_RRDV *pk_rrdv);		// ref_rdv
};
#endif

//Ĺס륢å饹
class FixedMemoryPool
{
    public:
	// 󥹥ȥ饯
	FixedMemoryPool(ID mpfid);			// IDֹΥå [S]
#if 0
	FixedMemoryPool(ID mpfid, T_CMPF *pk_cmpf);	// cre_mpf
	FixedMemoryPool(T_CMPF *pk_cmpf);		// acre_mpf
#endif

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// Ĺס뵡ǽ
	//ER	create(T_CMPF *pk_cmpf);		// cre_mpf
	//ER 	delete();				// del_mpf
	ER	get(VP *p_blk);				// get_mpf [S]
	ER	get(VP *p_blk, TMO tmout);		// tget_mpf [S]
	ER	pollGet(VP *p_blk);			// pget_mpf [S]
	ER	release(VP blk);			// rel_mpf [S]
	//ER	refer(T_RMPF *pk_rmpf);			// ref_mpf
    private:
	ID mpfid;
};


#if 0
//Ĺס륢å饹
class VariableMemoryPool
{
    public:
	// 󥹥ȥ饯
	VariableMemoryPool(ID mplid);			// IDֹΥå
	VariableMemoryPool(ID mplid, T_CMPL *pk_cmpl);	// cre_mpl
	VariableMemoryPool(T_CMPL *pk_cmpl);		// acre_mpl

	// IDֹμ
	ID	getId();				// IDֹμ

	// Ĺס뵡ǽ
	ER	create(T_CMPL *pk_cmpl);		// cre_mpl
	//ER 	delete();				// del_mpl
	ER	get(UINT blksz, VP *p_blk);		// get_mpl
	ER	get(UINT blksz, VP *p_blk, TMO tmout);	// tget_mpl
	ER	pollGet(UINT blksz, VP *p_blk);		// pget_mpl
	ER	release(VP blk);			// rel_mpl
	ER	refer(T_RMPL *pk_rmpl);			// ref_mpl
};
#endif

#if 0
//ϥɥ饢å饹
//() ϥɥϤ٤ϥɥεưϤϡ
// ХʴؿؤΥݥ󥿤Ǥ뤳ȡ
class CyclicHandler
{
    public:
	// 󥹥ȥ饯
	CyclicHandler(ID cycid);			// IDֹΥå [S]
	CyclicHandler(ID cycid, T_CCYC *pk_ccyc);	// cre_cyc
	CyclicHandler(T_CCYC *pk_ccyc);			// acre_cyc

	// IDֹμ
	ID	getId();				// IDֹμ [S]

	// ϥɥ鵡ǽ
	ER	create(T_CCYC *pk_ccyc);		// cre_cyc
	//ER 	delete();				// del_cyc
	ER	start();				// sta_cyc [S]
	ER	stop();					// stp_cyc [S]
	ER	refer(T_RCYC *pk_rcyc);			// ref_cyc
};
#endif

#if 0
//顼ϥɥ饢å饹
//() 顼ϥɥϤ٤
// 顼ϥɥεưϤϡ
// ХʴؿؤΥݥ󥿤Ǥ뤳ȡ
class AlarmHandler
{
    public:
	// 󥹥ȥ饯
	AlarmHandler(ID almid);				// IDֹΥå
	AlarmHandler(ID almid, T_CALM *pk_calm);	// cre_alm
	AlarmHandler(T_CALM *pk_calm);			// acre_alm

	// IDֹμ
	ID	getId();				// IDֹμ

	// 顼ϥɥ鵡ǽ
	ER	create(T_CALM *pk_calm);		// cre_alm
	//ER 	delete();				// del_alm
	ER	start(RELTIM almtim);			// sta_alm
	ER	stop();					// stp_alm
	ER	refer(T_RALM *pk_ralm);			// ref_alm
};
#endif

#if 0
//ߥӥ롼󥢥å饹
class InterruptServiceRoutine
{
    public:
	// 󥹥ȥ饯
	InterruptServiceRoutine(ID isrid);		// IDֹΥå
	InterruptServiceRoutine(ID isrid, T_CISR *pk_cisr);
							// cre_isr
	InterruptServiceRoutine(T_CISR *pk_cisr);	// acre_isr

	// IDֹμ
	ID	getId();				// IDֹμ

	// ߴǽ
	ER	create(T_CISR *pk_cisr);		// cre_isr
	//ER 	delete();				// del_isr
	ER	refer(T_RISR *pk_risr);			// ref_isr
};
#endif
